import processing.serial.*;
import processing.sound.*;
Amplitude amp;
AudioIn in;
float smoothedNum = 0;

Serial myPort;

Virus [] virus;
Clouds [] cloud;
Bird bird;
Timer timer;

PImage Birdimg;
PImage Virusimg;
PImage Cloudimg;

boolean buttonPressed;

int gameState;
int numberOfVirus = 1;
int buttonX, buttonY, buttonW, buttonH;
int numberofClouds = 5;
int interactionMode;

String S= "You Win! \n Press the mouse to restart";

SoundFile gameplayBGMusic;
SoundFile WinBGMusic;
SoundFile LoseBGMusic;

void setup() {
  size (1400, 600);
  printArray(Serial.list());
  String portname=Serial.list()[4];
  println(portname);
  myPort = new Serial(this, portname, 9600);
  //myPort.clear();
  //myPort.bufferUntil('\n');
  gameState=0;
  //Assume the start button has not been pressed
  buttonPressed = false;
  //Parameters for the start button
  buttonW=335;
  buttonH=100;
  textSize(buttonH);
  buttonX=(width-buttonW)/2;
  buttonY=(height-buttonH)/2;
  Birdimg= loadImage("Bird Picture #1.png");
  Virusimg= loadImage("Virus Picture #1.png");
  Cloudimg = loadImage ("Clouds.png");
  cloud = new Clouds [numberofClouds];
  for (int i=0; i<cloud.length; i++) {
    cloud[i] = new Clouds(Cloudimg);
  }
  virus = new Virus [numberOfVirus];
  for (int i=0; i< virus.length; i++) {
    virus[i] = new Virus(Virusimg);
  }
  bird = new Bird(Birdimg);
  timer = new Timer();
  amp = new Amplitude(this);
  in = new AudioIn(this, 0);
  in.start();
  amp.input(in);


  gameplayBGMusic = new SoundFile(this, "Gameplay BG Music.mp3");
  WinBGMusic = new SoundFile(this, "Win BG Music.mp3");
  LoseBGMusic = new SoundFile(this, "Lose BG Music.mp3");
}

void draw() {
  background(173, 253, 255);
  //start screen w/ instructions 
  println(interactionMode);
  if (gameState == 0) {
    //insert starting screen code here
    background(255);
    fill(237, 203, 29);
    String Instructions= "Instructions: \n Control the Bird Up & Down and Avoid All Viruses  \n \n Choose Control Mode: \n Red Button = Photoresistor \n Blue Button = Microphone\n\nControl Tutorial:\n Photoresistor= Hover and move your hand up and down the photoresistor \nMicrophone= Control the Bird with your voice \n\n NOTE: \n Each time you win, the Viruses will become faster next round \n \n"; 
    textAlign(CENTER);
    textSize(20);
    text(Instructions, width/2, height/2-250);
    fill(139, 0, 139);
    rect(buttonX, buttonY+200, buttonW+65, buttonH);
    fill(255);
    textSize(50);
    text("PRESS TO START", buttonX+200, buttonY+200+buttonH-10);
  } else if (gameState == 1) { //gameplay screen for Photoresistor Mode
    //insert game code here

    for (int i=0; i<virus.length; i++) {
      virus[i].drawVirus();
      virus[i].moveVirus();
    }
    for (int i=0; i<cloud.length; i++) {
      cloud[i].drawClouds();
      cloud[i].moveClouds();
    }
    bird.drawUserBird();
    bird.checkEdge();
    timer.showTimer();
    collisiondetection();

    if (interactionMode == 1) {
      float temporaryAmplitude;
      temporaryAmplitude = amp.analyze();
      temporaryAmplitude = map(temporaryAmplitude, 0, 0.2, height, 0);
      temporaryAmplitude = constrain(temporaryAmplitude, 0, height);

      //controlling the speed at which the object is reaching its destination
      //takes more frames to arrive at its destination
      bird.locy += (temporaryAmplitude- bird.locy)*.1;
    }
  } else if (gameState == 2) { //Win Screen
    //insert win screen code here
    //numberOfVirus= +1;
    //for (int i=0; i<virus.length; i++) {
    //  virus[i].xspeed -=5;
    //}
    gameplayBGMusic.stop();
    background(0);
    fill(random(255), random(255), random(255));
    textAlign(CENTER);
    textSize(80);
    text(S, width/2, height/2);
    if (mousePressed) {
      for (int i=0; i<virus.length; i++) {
        virus[i].xspeed -=10;
        virus[i].locx = width+50; //this makes them appear from off the screen
        virus[i].locy = random(height); //this makes it appear at random heights
        virus[i].timer1= millis()+1000; // this is the time interval for each virus appearing
      }
      WinBGMusic.stop();
      reset();
    }
  } else if (gameState == 3) { // Lose Screen
    //insert lose screen code here
    String G="You Lose! Game Over";
    String R="Press the mouse to restart";
    background(0);
    fill(random(255), random(255), random(255));
    textAlign(CENTER);
    textSize(80);
    text(G, width/2, height/2);
    textSize(50);
    text(R, width/2, height/2+100);
    if (mousePressed) {
      for (int i=0; i<virus.length; i++) {
        virus[i].locx = width+50; //this makes them appear from off the screen
        virus[i].locy = random(height); //this makes it appear at random heights
        virus[i].timer1= millis()+1000; // this is the time interval for each virus appearing
      }
      LoseBGMusic.stop();
      reset();
    }
  }
}


//if the start button is pressed
void mousePressed() {
  if ( mouseX > buttonX && mouseX < buttonX+buttonW+65 && mouseY > buttonY+200 && mouseY < (buttonY+200)+buttonH) {
    //buttonPressed=true;
    gameState=1;
    gameplayBGMusic.play();
    timer= new Timer();
  }
}


void reset() {
  gameState=0;
  //Assume the start button has not been pressed
  //buttonPressed = false;
  //Parameters for the start button
  buttonW=335;
  buttonH=100;
  textSize(buttonH);
  buttonX=(width-buttonW)/2;
  buttonY=(height-buttonH)/2;
  //Birdimg= loadImage("Bird Picture #1.png");
  //Virusimg= loadImage("Virus Picture #1.jpeg");
  //virus = new Virus [numberOfVirus];
  //for (int i=0; i< virus.length; i++) {
  //  virus[i] = new Virus(Virusimg);
  //}
  bird = new Bird(Birdimg);
  timer = new Timer();
}

void collisiondetection() {
  for (int i=0; i<virus.length; i++) {
    if (dist(virus[i].locx, virus[i].locy, bird.locx, bird.locy)< virus[i].viruswidth + bird.radius) {
      //println(dist(balls[i].locx, balls[i].locy, myBall.locx, myBall.locy));
      gameplayBGMusic.stop();
      LoseBGMusic.play();
      gameState=3; //if it collides, changes the boolean to true, making the lose screen appear
    }
  }
}

void serialEvent(Serial myPort) {
  //read string of information
  String s=myPort.readStringUntil('\n');
  s=trim(s);
  //if there's sth in s
  if (s!=null) {
    //split the string s based on commmas and put it into integer array "values"
    int values[]=int(split(s, ','));
    /*as long as there's a total of three arrays of information from Arduino
     */
    if (values.length==3 ) {
      if (interactionMode == 0) {
        //photoresistor value
        int temporaryBirdValue;
        temporaryBirdValue = values[0];
        //bird.locy=values[0];
        temporaryBirdValue =  (int(map(temporaryBirdValue, 390, 833, height, 0)));
        temporaryBirdValue = constrain(temporaryBirdValue, 0, height);

        //this is the smoothing algorithm for the bird movement 
        bird.locy += (temporaryBirdValue - bird.locy)*.05;
      }
      //this is values for blueswitch 
      if (values[1] ==1) { //if the blueswitch is pressed change to photoresistor mode
        interactionMode = 0;
      }
      //this is values for redswitch
      if (values[2] == 1) { //if the redswitch is pressed change to microphone mode
        interactionMode = 1;
      }
      //code to map the values of the photoresistor to the width of the screen
      //gotta change the values for the range of the photoresistor
    }
  }
  //println(xPos);
  myPort.write('0');
}
